function utf8_decode(t) {
  var retorno = '';
  try {
    retorno = decodeURIComponent(escape(t));
  }
  catch (err) {
    retorno = t;
  }
  return retorno;
}

jQuery(document).ready(function ($) {

  jQuery('#sellers-cidade').change(function () {
    var tipo_selected = $('#sellers-tipo').val();
    var estado_selected = $('#sellers-estado').val();
    var cidade_selected = $('#sellers-cidade').val();
    var tipo_de_obra = 'Edificações e Obras Especiais';
    if (tipo_selected == 'residencial') {
      tipo_de_obra = 'Obras Residenciais';
    }
    if (estado_selected != '' && cidade_selected != '') {
      window.dataLayer = window.dataLayer || [];
      dataLayer.push({
        'event': 'fale_com_vendedor',
        'eventCategory': 'Formulario',
        'eventAction': 'Envio',
        'eventLabel': 'Fale com Vendedor - ' + tipo_de_obra + ' - ' + estado_selected + ' - ' + cidade_selected
      });
      dataLayer.push({
        'event': 'fale_com_vendedor_cidade',
        'eventCategory': 'Formulario',
        'eventAction': 'Envio',
        'eventLabel': 'Fale com Vendedor - ' + cidade_selected
      });
      dataLayer.push({
        'event': 'fale_com_vendedor_estado',
        'eventCategory': 'Formulario',
        'eventAction': 'Envio',
        'eventLabel': 'Fale com Vendedor - ' + estado_selected
      });
      dataLayer.push({
        'event': 'fale_com_vendedor_obra',
        'eventCategory': 'Formulario',
        'eventAction': 'Envio',
        'eventLabel': 'Fale com Vendedor - ' + tipo_de_obra
      });
    }
  });

  var ESTADO_SELECIONADO = '';
  var CIDADE_SELECIONADA = '';
  var options = {
    onKeyPress: function (cpf, ev, el, op) {
      var masks = ['000.000.000-000', '00.000.000/0000-00'];
      $('.campoCPF input').mask((cpf.length > 14) ? masks[1] : masks[0], op);
    }
  }

  function ValidarCPF(cpf) {
    cpf = cpf.replace(/\D/g, '');
    if (cpf.toString().length != 11 || /^(\d)\1{10}$/.test(cpf)) return false;
    var result = true;
    [9, 10].forEach(function (j) {
      var soma = 0, r;
      cpf.split(/(?=)/).splice(0, j).forEach(function (e, i) {
        soma += parseInt(e) * ((j + 2) - (i + 1));
      });
      r = soma % 11;
      r = (r < 2) ? 0 : 11 - r;
      if (r != cpf.substring(j, j + 1)) result = false;
    });
    return result;
  }

  function ValidarCNPJ(cnpj) {
    cnpj = cnpj.replace(/[^\d]+/g, '');

    if (cnpj == '') return false;

    if (cnpj.length != 14)
      return false;

    // Elimina CNPJs invalidos conhecidos
    if (cnpj == "00000000000000" ||
      cnpj == "11111111111111" ||
      cnpj == "22222222222222" ||
      cnpj == "33333333333333" ||
      cnpj == "44444444444444" ||
      cnpj == "55555555555555" ||
      cnpj == "66666666666666" ||
      cnpj == "77777777777777" ||
      cnpj == "88888888888888" ||
      cnpj == "99999999999999")
      return false;

    // Valida DVs
    tamanho = cnpj.length - 2
    numeros = cnpj.substring(0, tamanho);
    digitos = cnpj.substring(tamanho);
    soma = 0;
    pos = tamanho - 7;
    for (i = tamanho; i >= 1; i--) {
      soma += numeros.charAt(tamanho - i) * pos--;
      if (pos < 2)
        pos = 9;
    }
    resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
    if (resultado != digitos.charAt(0))
      return false;

    tamanho = tamanho + 1;
    numeros = cnpj.substring(0, tamanho);
    soma = 0;
    pos = tamanho - 7;
    for (i = tamanho; i >= 1; i--) {
      soma += numeros.charAt(tamanho - i) * pos--;
      if (pos < 2)
        pos = 9;
    }
    resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
    if (resultado != digitos.charAt(1))
      return false;

    return true;
  }

  $(".campoTelefone input").mask('(99) 9999-99999');
  $(".campoTelefone input").mask('(99) 9999-99999');
  $('.campoNumero input').mask('99999999');
  $('.campocep input').mask('99999-999');

  jQuery(document).submit(function () {
    $(".loader").show();
  });

  jQuery(document).bind('gform_post_render', function(){
    $.ajax({
        url: window.location.href,
        type: "POST",
        data: {
            request_json : true,
            load_cidades: true,
            UF : ESTADO_SELECIONADO
        },
        dataType: 'json',
        cache: false,
        success: function(response){
            if(response.cidades){
                jQuery(".campoCidade select").html('');
                jQuery(".campoCidade select").append('<option value="" selected="selected">Selecione uma cidade</option>');
                $.each(response.cidades, function() {
                    jQuery(".campoCidade select").append('<option value="'+utf8_decode(this.nome)+'" '+((this.nome == CIDADE_SELECIONADA)? 'selected="selected"' : '')+'>'+utf8_decode(this.nome)+'</option>');
                });
            }
        }
    });

    $(".campoTelefone input").mask('(99) 9999-99999');
    $('.campoNumero input').mask('99999999');
    $('.campocep input').mask('99999-999');

    $(".campoEstado select").change(function(){
        jQuery(".campoCidade select").html('<option value="">Carregando...</option>');
        var UF = $('option:selected',this).val();
        var cidades = {
          'BA': ['Salvador'],
          'CE': ['Aquiraz', 'Eusébio', 'Fortaleza', 'Itaitinga', 'Caucaia'],
          'DF': ['Brasília'],
          'GO': ['Goiânia', 'Santo Antônio de Goiás', 'Senador Canedo', 'Aparecida de Goiânia'],
          'MG': ['Paraguaçu', 'Uberlândia'],
          'PA': ['Belém', 'Ananindeua', 'Marituba'],
          'PE': ['Floresta'],
          'PR': ['Almirante Tamandaré', 'Araucária', 'Campina Grande do Sul', 'Colombo', 'Curitiba', 'Fazenda Rio Grande', 'Mandirituba', 'Pinhais', 'Piraquara', 'Quatro Barras', 'São José dos Pinhais', 'Cafelândia', 'Arapongas', 'Cambé', 'Ibiporã', 'Jataizinho', 'Londrina', 'Rolândia', 'Doutor Camargo', 'Iguaraçu', 'Mandaguaçu', 'Mandaguari', 'Maringá', 'Ourizona', 'Paiçandu', 'Sarandi', 'Marialva'],
          'RJ': ['Rio de Janeiro'],
          'RS': ['Alvorada', 'Cachoeirinha', 'Canoas', 'Eldorado do Sul', 'Guaíba', 'Porto Alegre', 'Viamão', 'Campo Bom', 'Estância Velha', 'Esteio', 'Gravataí', 'Nova Santa Rita', 'Novo Hamburgo', 'Portão', 'São Leopoldo', 'Sapucaia do Sul'],
          'SP': ['Americana', 'Artur Nogueira', 'Cordeirópolis', 'Atibaia', 'Nova Odessa', 'Bom Jesus dos Perdões', 'Santa Bárbara d`Oeste', 'Américo Brasiliense', 'Araraquara', 'Ibaté', 'Matão', 'Rincão', 'Santa Lúcia', 'Assis', 'Cândido Mota', 'Echaporã', 'Lutécia', 'Maracaí', 'Palmital', 'Platina', 'Tarumã', 'Bragança Paulista', 'Jarinu', 'Mairiporã', 'Nazaré Paulista', 'Piracaia', 'Hortolândia', 'Paulínia', 'Botucatu', 'Itatinga', 'Pardinho', 'São Manuel', 'Campinas', 'Monte Mor', 'Valinhos', 'Barueri', 'Caieiras', 'Carapicuíba', 'Cotia', 'Embu', 'Itapevi', 'Jandira', 'Osasco', 'Santana de Parnaíba', 'São Lourenço da Serra', 'Taboão da Serra', 'Vargem Grande Paulista', 'Ferraz de Vasconcelos', 'Guarulhos', 'Itaquaquecetuba', 'Poá', 'Suzano', 'Alambari', 'Itapetininga', 'Capivari', 'Elias Fausto', 'Indaiatuba', 'Itu', 'Porto Feliz', 'Salto', 'São Paulo', 'Cabreúva', 'Cajamar', 'Campo Limpo Paulista', 'Francisco Morato', 'Itatiba', 'Itupeva', 'Jundiaí', 'Louveira', 'Várzea Paulista', 'Vinhedo', 'Araras', 'Conchal', 'Cosmópolis', 'Engenheiro Coelho', 'Iracemápolis', 'Limeira', 'Rio Claro', 'Santa Gertrudes', 'Getulina', 'Guaiçara', 'Guaimbê', 'Guarantã', 'Lins', 'Promissão', 'Sabino', 'Embu-Guaçu', 'Itapecerica da Serra', 'Diadema', 'Mauá', 'Ribeirão Pires', 'Rio Grande da Serra', 'Santo André', 'São Bernardo do Campo', 'São Caetano do Sul', 'Alumínio', 'Araçoiaba da Serra', 'Mairinque', 'Salto de Pirapora', 'Sorocaba', 'Votorantim', 'Canitar', 'Chavantes', 'Ibirarema', 'Ipaussu', 'Ourinhos', 'Ribeirão do Sul', 'Salto Grande', 'Descalvado', 'Pirassununga', 'Porto Ferreira', 'Santa Cruz da Conceição', 'Santa Cruz das Palmeiras', 'Santa Rita do Passa Quatro', 'Barrinha', 'Brodowski', 'Cravinhos', 'Dumont', 'Jardinópolis', 'Pontal', 'Pradópolis', 'Ribeirão Preto', 'Serrana', 'Sertãozinho', 'Bady Bassitt', 'Bálsamo', 'Cedral', 'Guapiaçu', 'Ibirá', 'Ipiguá', 'Jaci', 'Mirassol', 'Mirassolândia', 'Nova Aliança', 'Onda Verde', 'Potirendaba', 'São José do Rio Preto', 'Uchoa', 'Pilar do Sul', 'Piedade', 'Boituva', 'Cerquilho', 'Bauru', 'Pederneiras', 'Piratininga', 'Agudos', 'Tatuí'],
          'SC': ['Cocal do Sul', 'Criciúma', 'Forquilhinha', 'Içara', 'Maracajá', 'Morro da Fumaça', 'Nova Veneza', 'Siderópolis', 'Treviso', 'Urussanga', 'Florianópolis', 'Joinville', 'Presidente Castelo Branco', 'Águas Mornas', 'Biguaçu', 'Palhoça', 'Santo Amaro da Imperatriz', 'São José', 'Itajaí', 'Balneário Camboriú', 'Camboriú', 'Brusque', 'Gaspar', 'Ilhota', 'Navegantes', 'Balneário Rincão'],
        };

        jQuery(".campoCidade select").html('');
        $.each(cidades[UF].sort(), function (_, cidade) {
          jQuery(".campoCidade select").append('<option value="' + cidade + '" ' + '>' + cidade + '</option>');
        });
    });
  });
  
  $(".campoTelefone input").mask("(00) 0000-00009");
  $('.campoNumero input').mask('99999999');
  $('.campocep input').mask('99999-999');
  
  $('.campoCPF input').keyup(function () {
    $('.campoCPF input').length > 11 ? $('.campoCPF input').mask('00.000.000/0000-00', options) : $('.campoCPF input').mask('000.000.000-00#', options);
  });
  
  $.fn.onScreen = function () {
    var docViewTop = $(window).scrollTop();
    var docViewBottom = docViewTop + $(window).height();

    var elemTop = $(this).offset().top;
    var elemBottom = elemTop + $(this).height();
    return ((elemBottom <= docViewBottom) && (elemTop >= docViewTop));
  }

  if (!$(".footer").onScreen()) {
    $("#solicite-footer").addClass('bottom');
  } else {
    $("#solicite-footer").removeClass('bottom');
  }
});

function createCookie(name, value, days) {
  var expires;
  if (days) {
    var date = new Date();
    date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
    expires = '; expires=' + date.toGMTString();
  }
  else {
    expires = '';
  }
  document.cookie = name + '=' + value + expires + '; path=/';
}

function getCookie(c_name) {
  var c_start;
  var c_end;
  if (document.cookie.length > 0) {
    c_start = document.cookie.indexOf(c_name + '=');
    if (c_start != -1) {
      c_start = c_start + c_name.length + 1;
      c_end = document.cookie.indexOf(';', c_start);
      if (c_end == -1) {
        c_end = document.cookie.length;
      }
      return unescape(document.cookie.substring(c_start, c_end));
    }
  }
  return '';
}

(function (doc, $) {
  function checkVisible( elm, evalType ) {
    evalType = evalType || 'visible';

    var viewportHeight = $(window).height(),
      scrollTop = $(window).scrollTop(),
      y = $(elm).offset().top,
      elementHeight = $(elm).height();

    if (evalType === 'visible') return ((y < (viewportHeight + scrollTop)) && (y > (scrollTop - elementHeight)));
    if (evalType === 'above') return ((y < (viewportHeight + scrollTop)));
  }

  $(window).scroll(function(){

    if(checkVisible('.footer')) {
      $('.floating-button').addClass('position-relative');
      $('.floating-button').removeClass('position-fixed');
    } else {
      $('.floating-button').removeClass('position-relative');
      $('.floating-button').addClass('position-fixed');
    }


  });

  const html = doc.querySelectorAll('html')[0];
  const a11yControls = doc.querySelectorAll('.a11y');
  const body = doc.body;

  Array.prototype.forEach.call(a11yControls, (control) => {
    control.addEventListener('click', () => {
      const action = control.dataset.action;
      const highContrast = 'contrast';
      let fontSize = Number(html.style.fontSize.replace('px', ''));

      if (fontSize == '' || fontSize < 16) {
        fontSize = 16;
      }

      if (action === 'increase' && fontSize <= 25) {
        html.style.fontSize = fontSize + 1 + 'px';
      }

      if (action === 'decrease' && fontSize > 16) {
        html.style.fontSize = fontSize - 1 + 'px';
      }

      if (action === 'contrast') {
        body.classList.toggle(highContrast);
        const cookie = getCookie(highContrast);
        const cookieInfo = cookie === '1' ? 0 : 1;
        createCookie(highContrast, cookieInfo, cookieInfo);
      }
    });
  });

}(document, jQuery));
